package com.ruoyi.ibs.tabs.service;

import com.ruoyi.ibs.tabs.domain.dto.ListTabDTO;
import com.ruoyi.ibs.tabs.domain.dto.TabAddDTO;
import com.ruoyi.ibs.tabs.domain.dto.TabEditDTO;
import com.ruoyi.ibs.tabs.domain.dto.TabPotAddDTO;
import com.ruoyi.ibs.tabs.domain.entity.CustTabListInfo;
import com.ruoyi.ibs.tabs.domain.vo.*;

import java.rmi.ServerException;
import java.util.List;


/**
 * 指标层级关系Service接口
 * 
 * @author ruoyi
 * @date 2024-12-30
 */
public interface ICustTabListInfoService 
{

    /**
    * 查询指标口径    通过，查询标签\枚举值、
    */
    List<CustTabGroupVo> selectTabPotListInfoByTabType(Long tabType);


    /**
     * 查询指标层级关系
     * 
     * @param id 指标层级关系主键
     * @return 指标层级关系
     */
    public CustTabIdDetailVO selectCustTabListInfoById(Long id);

    public List<PotListVo> listPot(String tabThresholdType);
    /**
     * 查询指标层级关系列表
     *
     * @param tabName 指标名
     * @return 指标层级关系集合
     */
    public List<TopTabVo> selectTopTabList(String tabName,String custType);


    /**
     * 查询指标层级关系列表
     *
     * @param listTabDTO 指标名
     * @return 指标层级关系集合
     */
    public List<CustTabListVo> listTab(ListTabDTO listTabDTO);
    /**
     * 查询指标层级关系列表
     * 
     * @param custTabListInfo 指标层级关系
     * @return 指标层级关系集合
     */
    public List<CustTabListInfo> selectCustTabListInfoList(CustTabListInfo custTabListInfo);

    /**
     * 新增指标层级关系
     * 
     * @param tabAddDTO 指标层级关系
     * @return 结果
     */
    public int insertCustTabListInfo(TabAddDTO tabAddDTO) throws ServerException;

    /**
     * 修改指标层级关系
     * 
     * @param TabEditDTO 指标层级关系
     * @return 结果
     */
    public int updateCustTabListInfo(TabEditDTO tabEditDTO) throws ServerException;

    /**
     * 批量删除指标层级关系
     * 
     * @param ids 需要删除的指标层级关系主键集合
     * @return 结果
     */
    public int deleteCustTabListInfoByIds(Long[] ids);

    /**
     * 删除指标层级关系信息
     * 
     * @param id 指标层级关系主键
     * @return 结果
     */
    public int deleteCustTabListInfoById(Long id) throws ServerException;


    /**
     * 獲取指标关系sql
     * @param tabPotAddDTO
     * @return
     */
    public String getIndexRelaitonSql(TabPotAddDTO tabPotAddDTO);

    public int isStart(Long id,String status);
}
